package wanijo.wanijo2.domain

import org.springframework.data.jdbc.repository.query.Query
import org.springframework.data.repository.Repository

interface DocumentDao: Repository<Document, Int> {

    fun findAll(): List<Document>

    fun findById(id: Long): Document?

    fun findByName(name: String): List<Document>

    fun save(doc: Document)

    @Query(
        """
            SELECT doc.*
              FROM t_document doc
              JOIN t_tag tag
                ON doc.id = tag.t_document
             WHERE LOWER(tag.name) LIKE '%' || LOWER(:tagName) || '%'
        """
    )
    fun findByTagName(tagName: String): List<Document>

}
